<template>
  <div class="app-container">
    <crud-table
      @getList="fetchCollection"
      @go="go"
      @remove="remove"
      :resourceName="resourceName"
      :rows="collection.data"
      :loading="loading"
    >
      <template slot="columns">
        <el-table-column
          prop="deliveryDate" label="F. Entrega" :min-width="30" :formatter="formatDate"
        />
        <el-table-column
          prop="updatedAt" label="Ult. Modif." :min-width="40" :formatter="formatDateTime"
        />
        <el-table-column
          prop="state" label="Estado" :min-width="40">
          <template slot-scope="scope">
            <el-tag :type="stateToTagType(scope.row.state)">{{ $t(scope.row.state) }}</el-tag>
          </template>
        </el-table-column>
        <el-table-column
          prop="client.name" label="Cliente" :min-width="120" />
      </template>

      <el-row :gutter="20" slot="filters">
        <el-col :span="8">
          <app-date-range-filter
            v-model="filters.deliveryDate"
            @input="fetchCollection"
            type="daterange"
            helpText="Rango de F. Entrega"
            start-placeholder="ent. desde"
            end-placeholder="ent. hasta"/>
        </el-col>
        <el-col :span="8">
          <el-select
            @input="fetchCollection"
            v-model="filters.state.$in"
            placeholder="Estado" multiple>
            <el-option
              v-for="(state, idx) in orderStates"
              :key="idx"
              :label="$t(state)"
              :value="state">
            </el-option>
          </el-select>
        </el-col>
        <el-col :span="8">
          <el-select
            v-model="filters.client"
            placeholder="Cliente"
            :remote-method="filterClients"
            @input="fetchCollection"
            remote
            filterable
            clearable
          >
            <el-option
              v-for="client in filteredClients"
              :key="client._id"
              :label="client.name"
              :value="client._id" />
          </el-select>
        </el-col>
      </el-row>

      <!-- Operaciones -->
      <el-table-column slot="operations"
        label="Operaciones" :width="240" fixed="right" center>
        <el-row slot-scope="scope">
          <el-col v-if="can('update', scope.row)" :span="8">
            <el-button type="primary" size="mini" @click="go('update', scope.row._id)">
              Editar
            </el-button>
          </el-col>
          <el-col v-if="can('remove', scope.row)" :span="8">
            <el-button type="danger" size="mini" @click="remove(scope.row)">
              Borrar
            </el-button>
          </el-col>
          <el-col :span="8">
            <el-button type="info" size="mini" @click="goPrint(scope.row._id)">
              Imprimir
            </el-button>
          </el-col>
        </el-row>
      </el-table-column>
      <!-- Fin Operaciones -->
    </crud-table>
    <el-pagination
      background
      @current-change="paginate"
      layout="total, prev, pager, next"
      :page-size="collection.limit"
      :total="collection.total">
    </el-pagination>
  </div>
</template>

<script>
  import orderStates from '@/services/order-states'
  import { ModelBuilder } from '@/services/model-builder'
  import { DateTime } from 'luxon'
  import api from '@/feathers'
  import CrudTable from '@/common/crud-table.component'
  import CrudTableMixin from '@/common/crud-table.mixin'
  import AppDateRangeFilter from '@/common/date-range-filter'
  import { debounce } from 'lodash'
  import { filterQuery } from '@/common/query'

  export default {
    name: 'orders-list',
    mixins: [CrudTableMixin],
    components: {
      CrudTable,
      AppDateRangeFilter
    },
    data() {
      return {
        resourceName: {
          singular: 'Order',
          plural: 'Orders'
        },
        collection: {
          data: [],
          total: 0
        },
        filters: {
          $limit: 20,
          $skip: 0,
          state: { $in: [] },
          client: '',
          deliveryDate: this.getDefaultDeliveryDate(), // If setted on created it breaks the validation
        },
        filteredClients: [],
        loading: false
      }
    },
    computed: {
      query() {
        return filterQuery({
          $populate: ['client'],
          $sort: {updatedAt: -1}
        }, this.filters)
      }
    },
    getModelName() {
      return 'MyOrders'
    },
    async created() {
      this.routePrefix = 'my-orders'
      this.modelBuilder = new ModelBuilder('MyOrders')
      this.service = api.service('my-orders')
      this.clientsService = api.service('clients')
      this.getStates()

      await this.fetchCollection()
    },
    methods: {
      can(action, resource) {
        return this.$can(action, this.modelBuilder.build(resource))
      },
      async debouncedFetchCollection() {
        return debounce(this.fetchCollection, 500)()
      },
      goPrint(orderId) {
        // TODO: This could be improved to match crud mixin implementation
        const routeData = this.$router.resolve({
          name: 'orders-print',
          params: {id: orderId}
        })
        window.open(routeData.href, '_blank')
      },
      async fetchCollection() {
        this.loading = true
        const response = await this.service.find({
          query: this.query
        })
        this.collection = response
        this.loading = false
      },
      async filterClients(filterName) {
        const query = {name: {$search: filterName}}
        const clients = await this.clientsService.find({query})
        this.filteredClients = clients.data
      },
      getDefaultDeliveryDate() {
        const today = DateTime.local()
        return {
          $gte: today.startOf('week'),
          $lt: today.plus({days: 1})
        }
      },
      getStates() {
        this.orderStates = orderStates.getStates()
      },
      stateToTagType(state) {
        return orderStates.getColor(state)
      },
      formatDate(row, { property }) {
        const dt = DateTime.fromISO(row[property])
        return dt.toLocaleString()
      },
      formatDateTime(row, { property }) {
        const dt = DateTime.fromISO(row[property])
        return dt.toLocaleString(DateTime.DATETIME_MED)
      }
    }
  }
</script>
